DESCRIPTION = "Base tasks for a SOM image."
LICENSE = "MIT"
PR = "r0"

PACKAGE_ARCH = "${MACHINE_ARCH}"

inherit packagegroup

CL_BASE = "\
    bash \
    coreutils \
    curl \
    dropbear \
    libbz2 \
    libgcc \
    libnl \
    libnl-genl \
    libss \
    libstdc++ \
    libusb1 \
    libusb-compat \
    module-init-tools \
    os-release \
    packagegroup-criticallink-packagemgmt \
    packagegroup-core-tools-testapps \
"

CL_BASE_CLI = "\
    ncurses \
    ncurses-terminfo \
    vim \
"

CL_BASE_UTILS = "\
    bzip2 \
    file \
    gawk \
    lzo \
    zip \
"

CL_BASE_DEBUG = "\
    gdb \
    gdbserver \
"

CL_BASE_EXTRA = "\
    devmem2 \
    memtester \
    memtool \
    tcpdump \
"

CL_BASE_ALSA = "\
    alsa-lib \
    alsa-utils-amixer \
    alsa-utils-aplay \
    alsa-utils-speakertest \
"

CL_BASE_BLUETOOTH = "\
    bluez5 \
"

RDEPENDS_${PN} = "\
    ${DISTRO_EXTRA_RDEPENDS} \
    ${MACHINE_EXTRA_RDEPENDS} \
    ${CL_BASE} \
    ${CL_BASE_CLI} \
    ${CL_BASE_EXTRA} \
    ${CL_BASE_UTILS} \
    ${@bb.utils.contains('MACHINE_FEATURES', 'alsa', '${CL_BASE_ALSA}', '',d)} \
    ${@bb.utils.contains('MACHINE_FEATURES', 'bluetooth', '${CL_BASE_BLUETOOTH}', '',d)} \
    ${@bb.utils.contains('MACHINE_FEATURES', 'debug', '${CL_BASE_DEBUG}', '',d)} \
"

RRECOMMENDS_${PN} = "\
    ${DISTRO_EXTRA_RRECOMMENDS} \
    ${MACHINE_EXTRA_RRECOMMENDS} \
"
